"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes} checked by tsc
 */
Object.defineProperty(exports, "__esModule", { value: true });
var core_1 = require("@angular/core");
var common_1 = require("@angular/common");
var Subject_1 = require("rxjs/Subject");
var event_manager_plugin_1 = require("../__util/event-manager-plugin");
/**
 * Control event listeners with an observable operator without triggering change detection
 * every time the event fires
 *
 * Usage:
 * <button (observe.throttleTime-500.click)="foo()"></button>
 *
 * The method used must be present on the Observable object
 * e.g. through an explicit import:
 * import 'rxjs/add/operator/throttleTime';
 *
 *
 * To get finer-grained control and the possibility to add multiple observable operators
 * use the ObserveEventDirective.
 */
var ObserveEventPlugin = (function (_super) {
    __extends(ObserveEventPlugin, _super);
    function ObserveEventPlugin(doc) {
        return _super.call(this, doc) || this;
    }
    /**
     * @param {?} eventName
     * @return {?}
     */
    ObserveEventPlugin.prototype.supports = /**
     * @param {?} eventName
     * @return {?}
     */
    function (eventName) {
        return eventName.indexOf('observe.') === 0;
    };
    /**
     * @param {?} element
     * @param {?} eventName
     * @param {?} handler
     * @return {?}
     */
    ObserveEventPlugin.prototype.addEventListener = /**
     * @param {?} element
     * @param {?} eventName
     * @param {?} handler
     * @return {?}
     */
    function (element, eventName, handler) {
        var _this = this;
        return this.manager.getZone().runOutsideAngular(function () {
            var /** @type {?} */ eventRest = eventName.slice(8).split('.');
            var /** @type {?} */ fnParts = eventRest[0].split('-');
            var /** @type {?} */ fnName = fnParts[0];
            var /** @type {?} */ fnArg = (fnParts.length > 1) ? +fnParts[1] : undefined;
            var /** @type {?} */ delegateEvent = eventRest.slice(1).join('.');
            var /** @type {?} */ subject = new Subject_1.Subject();
            var /** @type {?} */ observable = subject.asObservable();
            if (observable[fnName]) {
                observable = (fnArg !== undefined)
                    ? observable[fnName](fnArg)
                    : observable[fnName]();
            }
            else {
                console.error('The function "' + fnName + '" does not exist on Observable!');
                return function () { };
            }
            observable.subscribe(function (x) { return _this.manager.getZone().run(function () { return handler(x); }); });
            var /** @type {?} */ listener = _this.manager.addEventListener(element, delegateEvent, function ($event) {
                subject.next($event);
            });
            return function () {
                listener();
                subject.complete();
            };
        });
    };
    ObserveEventPlugin.decorators = [
        { type: core_1.Injectable },
    ];
    /** @nocollapse */
    ObserveEventPlugin.ctorParameters = function () { return [
        { type: undefined, decorators: [{ type: core_1.Inject, args: [common_1.DOCUMENT,] },] },
    ]; };
    return ObserveEventPlugin;
}(event_manager_plugin_1.MyEventManagerPlugin));
exports.ObserveEventPlugin = ObserveEventPlugin;
function ObserveEventPlugin_tsickle_Closure_declarations() {
    /** @type {!Array<{type: !Function, args: (undefined|!Array<?>)}>} */
    ObserveEventPlugin.decorators;
    /**
     * @nocollapse
     * @type {function(): !Array<(null|{type: ?, decorators: (undefined|!Array<{type: !Function, args: (undefined|!Array<?>)}>)})>}
     */
    ObserveEventPlugin.ctorParameters;
}
