"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes} checked by tsc
 */
Object.defineProperty(exports, "__esModule", { value: true });
var core_1 = require("@angular/core");
var event_manager_plugin_1 = require("../__util/event-manager-plugin");
var common_1 = require("@angular/common");
/**
 * Listen to events that are fired outside of the current element and its children
 *
 * Usage:
 * <div (outside.click)="close()"></div>
 *
 */
var OutsideEventPlugin = (function (_super) {
    __extends(OutsideEventPlugin, _super);
    function OutsideEventPlugin(doc) {
        return _super.call(this, doc) || this;
    }
    /**
     * @param {?} eventName
     * @return {?}
     */
    OutsideEventPlugin.prototype.supports = /**
     * @param {?} eventName
     * @return {?}
     */
    function (eventName) {
        return eventName.indexOf('outside.') === 0;
    };
    /**
     * @param {?} element
     * @param {?} eventName
     * @param {?} handler
     * @return {?}
     */
    OutsideEventPlugin.prototype.addEventListener = /**
     * @param {?} element
     * @param {?} eventName
     * @param {?} handler
     * @return {?}
     */
    function (element, eventName, handler) {
        var /** @type {?} */ realEventName = eventName.slice(8);
        return this.manager.addGlobalEventListener('document', realEventName, function (e) {
            if (element !== e.target && !element.contains(/** @type {?} */ (e.target))) {
                handler(e);
            }
        });
    };
    OutsideEventPlugin.decorators = [
        { type: core_1.Injectable },
    ];
    /** @nocollapse */
    OutsideEventPlugin.ctorParameters = function () { return [
        { type: undefined, decorators: [{ type: core_1.Inject, args: [common_1.DOCUMENT,] },] },
    ]; };
    return OutsideEventPlugin;
}(event_manager_plugin_1.MyEventManagerPlugin));
exports.OutsideEventPlugin = OutsideEventPlugin;
function OutsideEventPlugin_tsickle_Closure_declarations() {
    /** @type {!Array<{type: !Function, args: (undefined|!Array<?>)}>} */
    OutsideEventPlugin.decorators;
    /**
     * @nocollapse
     * @type {function(): !Array<(null|{type: ?, decorators: (undefined|!Array<{type: !Function, args: (undefined|!Array<?>)}>)})>}
     */
    OutsideEventPlugin.ctorParameters;
}
