import { InjectionToken } from "@angular/core";
import { MyEventManagerPlugin } from "../__util/event-manager-plugin";
export declare const SCROLL_EVENT_TIME: InjectionToken<string>;
/**
 * Detects when an element is scrolled into or out of the viewport
 *
 * Usage:
 * <div (scroll-in)="activate()" (scroll-out)="deactivate()">...</div>
 *
 * The matching handler of the initial status is called upon attaching
 * to notify the element of its current status. $event is true for the
 * initial call, false otherwise
 *
 */
export declare class ScrollEventPlugin extends MyEventManagerPlugin {
    private listeners;
    private globalListener;
    private subject;
    constructor(doc: any, time: number);
    supports(eventName: string): boolean;
    addEventListener(element: HTMLElement, eventName: string, handler: Function): Function;
    private updateGlobalListener();
    private getStatus(element);
}
