"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes} checked by tsc
 */
Object.defineProperty(exports, "__esModule", { value: true });
var core_1 = require("@angular/core");
var common_1 = require("@angular/common");
var event_manager_plugin_1 = require("../__util/event-manager-plugin");
var Subject_1 = require("rxjs/Subject");
var operators_1 = require("rxjs/operators");
exports.SCROLL_EVENT_TIME = new core_1.InjectionToken('ScrollEventTime');
/**
 * Detects when an element is scrolled into or out of the viewport
 *
 * Usage:
 * <div (scroll-in)="activate()" (scroll-out)="deactivate()">...</div>
 *
 * The matching handler of the initial status is called upon attaching
 * to notify the element of its current status. $event is true for the
 * initial call, false otherwise
 *
 */
var ScrollEventPlugin = (function (_super) {
    __extends(ScrollEventPlugin, _super);
    function ScrollEventPlugin(doc, time) {
        var _this = _super.call(this, doc) || this;
        _this.listeners = [];
        _this.globalListener = undefined;
        _this.subject = new Subject_1.Subject();
        _this.subject
            .pipe(operators_1.auditTime(time))
            .subscribe(function () {
            _this.listeners.forEach(function (x) { return x(); });
        });
        return _this;
    }
    /**
     * @param {?} eventName
     * @return {?}
     */
    ScrollEventPlugin.prototype.supports = /**
     * @param {?} eventName
     * @return {?}
     */
    function (eventName) {
        return eventName === 'scroll-in' || eventName === 'scroll-out';
    };
    /**
     * @param {?} element
     * @param {?} eventName
     * @param {?} handler
     * @return {?}
     */
    ScrollEventPlugin.prototype.addEventListener = /**
     * @param {?} element
     * @param {?} eventName
     * @param {?} handler
     * @return {?}
     */
    function (element, eventName, handler) {
        var _this = this;
        var /** @type {?} */ isScrollIn = (eventName === 'scroll-in');
        var /** @type {?} */ status = undefined;
        setTimeout(function () {
            status = _this.getStatus(element);
            if ((isScrollIn && status) || (!isScrollIn && !status)) {
                handler(true);
            }
        }, 0);
        var /** @type {?} */ listener = function () {
            var /** @type {?} */ newStatus = _this.getStatus(element);
            if (status === newStatus)
                return;
            if ((isScrollIn && newStatus) || (!isScrollIn && !newStatus)) {
                _this.manager.getZone().run(function () { return handler(false); });
            }
            status = newStatus;
        };
        this.listeners.push(listener);
        this.updateGlobalListener();
        return function () {
            var /** @type {?} */ index = _this.listeners.indexOf(listener);
            if (index === -1)
                return;
            _this.listeners.splice(index, 1);
            _this.updateGlobalListener();
        };
    };
    /**
     * @return {?}
     */
    ScrollEventPlugin.prototype.updateGlobalListener = /**
     * @return {?}
     */
    function () {
        var _this = this;
        if (this.listeners.length && this.globalListener === undefined) {
            this.manager.getZone().runOutsideAngular(function () {
                var /** @type {?} */ handler = function () {
                    _this.subject.next();
                };
                var /** @type {?} */ listeners = ['scroll', 'resize', 'orientationchange']
                    .map(function (x) { return _this.manager.addGlobalEventListener('window', x, handler); });
                _this.globalListener = function () {
                    listeners.forEach(function (x) { return x(); });
                };
            });
        }
        else if (!this.listeners.length && this.globalListener !== undefined) {
            this.globalListener();
            this.globalListener = undefined;
        }
    };
    /**
     * @param {?} element
     * @return {?}
     */
    ScrollEventPlugin.prototype.getStatus = /**
     * @param {?} element
     * @return {?}
     */
    function (element) {
        var /** @type {?} */ rect = element.getBoundingClientRect();
        return (rect.bottom >= 0 && rect.top <= window.innerHeight);
    };
    ScrollEventPlugin.decorators = [
        { type: core_1.Injectable },
    ];
    /** @nocollapse */
    ScrollEventPlugin.ctorParameters = function () { return [
        { type: undefined, decorators: [{ type: core_1.Inject, args: [common_1.DOCUMENT,] },] },
        { type: undefined, decorators: [{ type: core_1.Inject, args: [exports.SCROLL_EVENT_TIME,] },] },
    ]; };
    return ScrollEventPlugin;
}(event_manager_plugin_1.MyEventManagerPlugin));
exports.ScrollEventPlugin = ScrollEventPlugin;
function ScrollEventPlugin_tsickle_Closure_declarations() {
    /** @type {!Array<{type: !Function, args: (undefined|!Array<?>)}>} */
    ScrollEventPlugin.decorators;
    /**
     * @nocollapse
     * @type {function(): !Array<(null|{type: ?, decorators: (undefined|!Array<{type: !Function, args: (undefined|!Array<?>)}>)})>}
     */
    ScrollEventPlugin.ctorParameters;
    /** @type {?} */
    ScrollEventPlugin.prototype.listeners;
    /** @type {?} */
    ScrollEventPlugin.prototype.globalListener;
    /** @type {?} */
    ScrollEventPlugin.prototype.subject;
}
